typedef void  (Ns_AdpParserProc)(Ns_DString *, char *);

typedef struct AdpData {
    int	               exception;
    int                depth;
    int                argc;
    char             **argv;
    char              *cwd;
    char              *mimeType;
    int                evalLevel;
    int                errorLevel;
    int                debugLevel;
    int                debugInit;
    char              *debugFile;
    Ns_DString	       output;
    Ns_Conn           *conn;
    int                fStream;
    Ns_AdpParserProc  *parserProc;
    /* Ns_Cache	      *cachePtr; */
} AdpData;

#define ADP_OK       0
#define ADP_BREAK    1
#define ADP_ABORT    2
#define ADP_OVERFLOW 3
#define ADP_RETURN   4

void NsAdpInit (void);
void NsAdpFlush(AdpData *adPtr);
int Ns_AdpRequest(Ns_Conn *conn, char *file);
AdpData *NsAdpGetData ();
void add_adp_commands (Tcl_Interp *interp);
extern Ns_ModLogHandle nsAdpModLogHandle;
void FancyParsePage(Ns_DString *outPtr, char *in);
void NsAdpFancyInit(char *hServer, char *path);

void NsAdpLogError(Tcl_Interp *interp, char *file, int chunk);

ns_tcl_command NsTclParseHeaderCmd;
ns_tcl_command NsTclPutsCmd;
ns_tcl_command NsTclDirCmd;
ns_tcl_command NsTclBreakCmd;
ns_tcl_command NsTclExceptionCmd;
ns_tcl_command NsTclArgcCmd;
ns_tcl_command NsTclArgvCmd;
ns_tcl_command NsTclBindCmd;
ns_tcl_command NsTclTellCmd;
ns_tcl_command NsTclTruncCmd;
ns_tcl_command NsTclDumpCmd;
ns_tcl_command NsTclAdpEvalCmd;
ns_tcl_command NsTclAdpParseCmd;
ns_tcl_command NsTclStreamCmd;
ns_tcl_command NsTclDebugCmd;
ns_tcl_command NsTclAdpMimeCmd;
ns_tcl_command NsTclRegisterTagCmd;
ns_tcl_command NsTclRegisterAdpCmd;
