################################################################
#
# Miscellany

# ns_atclose --- adds to a list of hooks run at aolserver_cleanup

lappend per_req_vars atclose_scripts

proc ns_atclose {args} {
    global atclose_scripts

    if {[llength $args] == 0} {
	error "No arguments supplied to ns_atclose"
    } elseif {[llength $args] == 1} {
	run_at atclose [lindex $args 0]
    } else {
	run_at atclose $args
    }

    return ""
}

$slaveInterp alias ns_atclose ns_atclose

# ns_perm "emulation" --- also modlogcontrol

proc we_dont_bother_with_this {args} { return "OK" }
$slaveInterp alias ns_checkurl we_dont_bother_with_this
$slaveInterp alias ns_requestauthorize we_dont_bother_with_this
$slaveInterp alias ns_modlogcontrol we_dont_bother_with_this

# ns_httptime

proc ns_httptime { time } { ns_fmttime $time "%a, %d %b %Y %H:%M:%S GMT" GMT }

$slaveInterp alias ns_httptime ns_httptime

# The one invocation of this routine in ACS doesn't actually
# look at the headers (ad-robots.tcl), so we don't bother with
# them here; it would be better (and more honest) to just change
# ad-robot-defs to call ns_httpopen directly, and delete this stub.
# (There are differences; this times out and and follows redirects).
    
# Note that this requires the aolserver http.tcl file to be loaded...

$slaveInterp eval { proc ns_geturl {url headerdummy} {ns_httpget $url} }
    
