# $Header: /cvsweb/mod_aolserver/aol_bootstrap/shared_vars.tcl,v 1.8 2000/05/08 00:39:28 rst Exp $

# This file contains a bogus implementation of ns_share which just
# saves stuff in globals; they do not dynamically share data between
# interpreters.  Shared values set at init time will be available to
# the Apache children, though. This works for ACS because we usually
# do not use ns_share and nsv_* to hold dynamic data.

# It also initializes nsv and ns_mutex, which currently work.

_nsv_shm_init \
    [ap_config_filename nsv_shmem_file logs/aolsrv_shmem] \
    [ap_config_filename lockfile       logs/aolsrv_lock] \
    [ap_config_arg      nsv_shmem_size [expr 3 << 20]]

run_at cleanup [list $slaveInterp eval _ns_cleanup_globals]

$slaveInterp eval {

    proc _ns_cleanup_globals {} {
	global _ns_shared_vars

	foreach g [info globals] {
	    if {![string match tcl* $g]
	    && ![string match error* $g]
	    && ![string match _nsv__* $g]
	    && [string compare _ns_shared_vars $g] != 0
	    && ![info exists _ns_shared_vars($g)]
	    && [string compare env $g] != 0} {
		upvar #0 $g var
		if [info exists var] {
		    unset var
		}
	    }
	}
    }

    proc ns_share {args} {
	if {[string compare [lindex $args 0] "-init"] == 0} {
	    if {[llength $args] != 3} {
		error "wrong # args: should be \"ns_share -init script varName\""
	    }
	    set initScript [lindex $args 1]
	    set args [lrange $args 2 end]
	}

	global _ns_shared_vars

	foreach varname $args {
	    set _ns_shared_vars($varname) 1
	    uplevel [list global $varname]
	}

	if {[info exists initScript]} {
	    global _ns_share_init_p
	    if {![info exists _ns_share_init_p($varname)]} {
		set _ns_share_init_p($varname) 1
		uplevel $initScript
	    }
	}
    }
}

